--- chan_unistim.c.orig	2011-10-11 11:33:06.000000000 -0500
+++ chan_unistim.c	2011-10-11 11:42:22.000000000 -0500
@@ -2234,73 +2611,155 @@
 		buffsend[46] = (htons(sin.sin_port) & 0x00ff);
 		buffsend[47] = (rtcpsin_port & 0xff00) >> 8;
 		buffsend[48] = (rtcpsin_port & 0x00ff);
-		send_client(SIZE_HEADER + sizeof(packet_send_call), buffsend,
-				   sub->parent->parent->session);
+		send_client(SIZE_HEADER + sizeof(packet_send_call), buffsend, pte);
 	}
-	ast_mutex_unlock(&sub->lock);
 }
 
-static void SendDialTone(struct unistimsession *pte)
+static void start_rtp(struct unistim_subchannel *sub)
 {
-	int i;
-	/* No country defined ? Using US tone */
-	if (ast_strlen_zero(pte->device->country)) {
-		if (unistimdebug)
-			ast_verb(0, "No country defined, using US tone\n");
-		send_tone(pte, 350, 440);
+	struct sockaddr_in sin = { 0, };
+	struct sockaddr_in sout = { 0, };
+	struct ast_sockaddr sin_tmp;
+	struct ast_sockaddr sout_tmp;
+
+	/* Sanity checks */
+	if (!sub) {
+		ast_log(LOG_WARNING, "start_rtp with a null subchannel !\n");
 		return;
 	}
-	if (strlen(pte->device->country) != 2) {
-		if (unistimdebug)
-			ast_verb(0, "Country code != 2 char, using US tone\n");
-		send_tone(pte, 350, 440);
+	if (!sub->parent) {
+		ast_log(LOG_WARNING, "start_rtp with a null line!\n");
 		return;
 	}
-	i = 0;
-	while (frequency[i].freq1) {
-		if ((frequency[i].country[0] == pte->device->country[0]) &&
-			(frequency[i].country[1] == pte->device->country[1])) {
-			if (unistimdebug)
-				ast_verb(0, "Country code found (%s), freq1=%d freq2=%d\n",
-							frequency[i].country, frequency[i].freq1, frequency[i].freq2);
-			send_tone(pte, frequency[i].freq1, frequency[i].freq2);
+	if (!sub->parent->parent) {
+		ast_log(LOG_WARNING, "start_rtp with a null device!\n");
+		return;
+	}
+	if (!sub->parent->parent->session) {
+		ast_log(LOG_WARNING, "start_rtp with a null session!\n");
+		return;
+	}
+	if (!sub->owner) {
+		ast_log(LOG_WARNING, "start_rtp with a null asterisk channel!\n");
+		return;
+	}
+	sout = sub->parent->parent->session->sout;
+	sout.sin_family = AF_INET;
+	ast_mutex_lock(&sub->lock);
+	/* Allocate the RTP */
+	if (unistimdebug)
+		ast_verb(0, "Starting RTP. Bind on %s\n", ast_inet_ntoa(sout.sin_addr));
+	ast_sockaddr_from_sin(&sout_tmp, &sout);
+	sub->rtp = ast_rtp_instance_new("asterisk", sched, &sout_tmp, NULL);
+	if (!sub->rtp) {
+		ast_log(LOG_WARNING, "Unable to create RTP session: %s binaddr=%s\n",
+				strerror(errno), ast_inet_ntoa(sout.sin_addr));
+		ast_mutex_unlock(&sub->lock);
+		return;
+	}
+	ast_rtp_instance_set_prop(sub->rtp, AST_RTP_PROPERTY_RTCP, 1);
+	sub->owner->fds[0] = ast_rtp_instance_fd(sub->rtp, 0);
+	sub->owner->fds[1] = ast_rtp_instance_fd(sub->rtp, 1);
+	ast_rtp_instance_set_qos(sub->rtp, qos.tos_audio, qos.cos_audio, "UNISTIM RTP");
+	ast_rtp_instance_set_prop(sub->rtp, AST_RTP_PROPERTY_NAT, sub->parent->parent->nat);
+
+	/* Create the RTP connection */
+	sin.sin_family = AF_INET;
+	/* Setting up RTP for our side */
+	memcpy(&sin.sin_addr, &sub->parent->parent->session->sin.sin_addr,
+		   sizeof(sin.sin_addr));
+
+	sin.sin_port = htons(find_rtp_port(sub));
+	ast_sockaddr_from_sin(&sin_tmp, &sin);
+	ast_rtp_instance_set_remote_address(sub->rtp, &sin_tmp);
+	if (!(sub->owner->nativeformats & sub->owner->readformat)) {
+		format_t fmt;
+		char tmp[256];
+		fmt = ast_best_codec(sub->owner->nativeformats);
+		ast_log(LOG_WARNING,
+				"Our read/writeformat has been changed to something incompatible: %s, using %s best codec from %s\n",
+				ast_getformatname(sub->owner->readformat),
+				ast_getformatname(fmt),
+				ast_getformatname_multiple(tmp, sizeof(tmp), sub->owner->nativeformats));
+                
+                sub->owner->readformat = fmt;
+                sub->owner->writeformat = fmt;
+	}
+	send_start_rtp(sub);
+	ast_mutex_unlock(&sub->lock);
+}
+
+static void send_dial_tone(struct unistimsession *pte)
+{
+	struct ast_tone_zone_sound *ts = NULL;
+	struct ast_tone_zone_part tone_data;
+	char *s = NULL;
+	char *ind;
+
+	if ((ts = ast_get_indication_tone(pte->device->tz, "dial"))) {
+		ind = ast_strdupa(ts->data);
+		s = strsep(&ind, ",");
+		ast_tone_zone_part_parse(s, &tone_data);
+		if (tone_data.modulate) {
+			tone_data.freq2 = 0;
 		}
-		i++;
+		send_tone(pte, tone_data.freq1, tone_data.freq2);
+		if (unistimdebug)
+			ast_verb(0, "Country code found (%s), freq1=%d freq2=%d\n",
+							pte->device->tz->country, tone_data.freq1, tone_data.freq2);
+
+		ts = ast_tone_zone_sound_unref(ts);
 	}
 }
 
+static void show_phone_number(struct unistimsession *pte)
+{
+	char tmp[TEXT_LENGTH_MAX + 1];
+	const char *tmp_number = ustmtext("Number:", pte);
+	int line, tmp_copy, offset = 0, i;
+
+	pte->device->phone_number[pte->device->size_phone_number] = '\0';
+	if  (pte->device->size_phone_number > MAX_SCREEN_NUMBER) {
+		offset = pte->device->size_phone_number - MAX_SCREEN_NUMBER - 1;
+		if (offset > strlen(tmp_number))
+			offset = strlen(tmp_number);
+		tmp_copy = strlen(tmp_number) - offset + 1;
+		if (tmp_copy > sizeof(tmp))
+			tmp_copy = sizeof(tmp);
+		memcpy(tmp, tmp_number + offset, tmp_copy);
+	} else {
+		ast_copy_string(tmp, tmp_number, sizeof(tmp));
+	}
+
+	offset = (pte->device->size_phone_number >= TEXT_LENGTH_MAX) ? (pte->device->size_phone_number - TEXT_LENGTH_MAX +1) : 0;
+	if (pte->device->size_phone_number) {
+		memcpy(tmp + strlen(tmp), pte->device->phone_number + offset, pte->device->size_phone_number - offset + 1);
+	}
+	offset = strlen(tmp);
+
+	for (i = strlen(tmp); i < TEXT_LENGTH_MAX; i++) {
+		tmp[i] = '.';
+	}
+	tmp[i] = '\0';
+
+	line = (pte->device->height == 1) ? TEXT_LINE0 : TEXT_LINE2;
+	send_text(line, TEXT_NORMAL, pte, tmp);
+	send_blink_cursor(pte);
+	send_cursor_pos(pte, (unsigned char) (line + offset));
+	send_led_update(pte, 0);
+}
+
 static void handle_dial_page(struct unistimsession *pte)
 {
 	pte->state = STATE_DIALPAGE;
 	if (pte->device->call_forward[0] == -1) {
 		send_text(TEXT_LINE0, TEXT_NORMAL, pte, "");
-		send_text(TEXT_LINE1, TEXT_NORMAL, pte, "Enter forward");
-		send_text_status(pte, "ForwardCancel BackSpcErase");
+		send_text(TEXT_LINE1, TEXT_NORMAL, pte, ustmtext("Enter forward", pte));
+		send_text_status(pte, ustmtext("Fwd    Cancel BackSp Erase", pte));
 		if (pte->device->call_forward[1] != 0) {
-			char tmp[TEXT_LENGTH_MAX + 1];
-
 			ast_copy_string(pte->device->phone_number, pte->device->call_forward + 1,
 							sizeof(pte->device->phone_number));
-			pte->device->size_phone_number = strlen(pte->device->phone_number);
-			if (pte->device->size_phone_number > 15)
-				pte->device->size_phone_number = 15;
-			strcpy(tmp, "Number : ...............");
-			memcpy(tmp + 9, pte->device->phone_number, pte->device->size_phone_number);
-
-			if (pte->device->height == 1) {
-				send_text(TEXT_LINE0, TEXT_NORMAL, pte, tmp);
-				send_blink_cursor(pte);
-				send_cursor_pos(pte,
-						  (unsigned char) (TEXT_LINE0 + 0x09 +
-										   pte->device->size_phone_number));
-			} else {
-				send_text(TEXT_LINE2, TEXT_NORMAL, pte, tmp);
-				send_blink_cursor(pte);
-				send_cursor_pos(pte,
-						  (unsigned char) (TEXT_LINE2 + 0x09 +
-										   pte->device->size_phone_number));
-			}
-
+			show_phone_number(pte);
 			send_led_update(pte, 0);
 			return;
 		}
@@ -2310,200 +2769,294 @@
 			send_select_output(pte, OUTPUT_SPEAKER, pte->device->volume, MUTE_OFF);
 		else
 			send_select_output(pte, pte->device->output, pte->device->volume, MUTE_OFF);
-		SendDialTone(pte);
+		send_dial_tone(pte);
 
 		if (pte->device->height > 1) {
-			send_text(TEXT_LINE0, TEXT_NORMAL, pte, "Enter the number to dial");
-			send_text(TEXT_LINE1, TEXT_NORMAL, pte, "and press Call");
+			send_text(TEXT_LINE0, TEXT_NORMAL, pte, ustmtext("Enter the number to dial", pte));
+			send_text(TEXT_LINE1, TEXT_NORMAL, pte, ustmtext("and press Call", pte));
 		}
-		send_text_status(pte, "Call   Redial BackSpcErase");
+		send_text_status(pte, ustmtext("Call   Redial BackSp Erase", pte));
 	}
 
-	if (pte->device->height == 1) {
-		send_text(TEXT_LINE0, TEXT_NORMAL, pte, "Number : ...............");
-		send_blink_cursor(pte);
-		send_cursor_pos(pte, TEXT_LINE0 + 0x09);
-	} else {
-		send_text(TEXT_LINE2, TEXT_NORMAL, pte, "Number : ...............");
-		send_blink_cursor(pte);
-		send_cursor_pos(pte, TEXT_LINE2 + 0x09);
-	}
 	pte->device->size_phone_number = 0;
 	pte->device->phone_number[0] = 0;
+	show_phone_number(pte);
 	change_favorite_icon(pte, FAV_ICON_PHONE_BLACK);
-	Sendicon(TEXT_LINE0, FAV_ICON_NONE, pte);
+	send_icon(TEXT_LINE0, FAV_ICON_NONE, pte);
 	pte->device->missed_call = 0;
 	send_led_update(pte, 0);
 	return;
 }
 
-/* Step 1 : Music On Hold for peer, Dialing screen for us */
-static void TransferCallStep1(struct unistimsession *pte)
+static void swap_subs(struct unistim_subchannel *a, struct unistim_subchannel *b)
 {
-	struct unistim_subchannel *sub;
-	struct unistim_line *p = pte->device->lines;
+/*  struct ast_channel *towner; */
+	struct ast_rtp_instance *rtp;
+	int fds;
 
-	sub = p->subs[SUB_REAL];
+	if (unistimdebug)
+		ast_verb(0, "Swapping %p and %p\n", a, b);
 
-	if (!sub->owner) {
-		ast_log(LOG_WARNING, "Unable to find subchannel for music on hold\n");
+	if ((!a->owner) || (!b->owner)) {
+		ast_log(LOG_WARNING,
+				"Attempted to swap subchannels with a null owner : sub #%p=%p sub #%p=%p\n",
+				a, a->owner, b, b->owner);
 		return;
 	}
-	if (p->subs[SUB_THREEWAY]) {
-		if (unistimdebug)
-			ast_verb(0, "Transfer canceled, hangup our threeway channel\n");
-		if (p->subs[SUB_THREEWAY]->owner)
-			ast_queue_hangup_with_cause(p->subs[SUB_THREEWAY]->owner, AST_CAUSE_NORMAL_CLEARING);
-		else
-			ast_log(LOG_WARNING, "Canceling a threeway channel without owner\n");
+	rtp = a->rtp;
+	a->rtp = b->rtp;
+	b->rtp = rtp;
+
+	fds = a->owner->fds[0];
+	a->owner->fds[0] = b->owner->fds[0];
+	b->owner->fds[0] = fds;
+
+	fds = a->owner->fds[1];
+	a->owner->fds[1] = b->owner->fds[1];
+	b->owner->fds[1] = fds;
+}
+
+/* Step 1 : Music On Hold for peer, Dialing screen for us */
+static void transfer_call_step1(struct unistimsession *pte)
+{
+	struct unistim_subchannel *sub, *sub_trans;
+	struct unistim_device *d = pte->device;
+
+	sub = get_sub(d, SUB_REAL);
+	sub_trans = get_sub(d, SUB_THREEWAY);
+
+	if (!sub || !sub->owner) {
+		ast_log(LOG_WARNING, "Unable to find subchannel for music on hold\n");
 		return;
 	}
 	/* Start music on hold if appropriate */
-	if (pte->device->moh)
+	if (sub->moh)
 		ast_log(LOG_WARNING, "Transfer with peer already listening music on hold\n");
 	else {
-		if (ast_bridged_channel(p->subs[SUB_REAL]->owner)) {
-			ast_moh_start(ast_bridged_channel(p->subs[SUB_REAL]->owner),
-						  pte->device->lines->musicclass, NULL);
-			pte->device->moh = 1;
+		if (ast_bridged_channel(sub->owner)) {
+			ast_moh_start(ast_bridged_channel(sub->owner),
+						  sub->parent->musicclass, NULL);
+			sub->moh = 1;
+			sub->subtype = SUB_THREEWAY;
 		} else {
 			ast_log(LOG_WARNING, "Unable to find peer subchannel for music on hold\n");
 			return;
 		}
 	}
-	/* Silence our channel */
-	if (!pte->device->silence_generator) {
-		pte->device->silence_generator =
-			ast_channel_start_silence_generator(p->subs[SUB_REAL]->owner);
-		if (pte->device->silence_generator == NULL)
-			ast_log(LOG_WARNING, "Unable to start a silence generator.\n");
-		else if (unistimdebug)
-			ast_verb(0, "Starting silence generator\n");
-	}
+	sub_start_silence(pte, sub);
 	handle_dial_page(pte);
 }
 
+static void transfer_cancel_step2(struct unistimsession *pte)
+{
+	struct unistim_subchannel *sub, *sub_trans;
+	struct unistim_device *d = pte->device;
+
+	sub = get_sub(d, SUB_REAL);
+	sub_trans = get_sub(d, SUB_THREEWAY);
+
+	if (!sub || !sub->owner) {
+		ast_log(LOG_WARNING, "Unable to find subchannel for music on hold\n");
+		return;
+	}
+	if (sub_trans) {
+		if (unistimdebug)
+			ast_verb(0, "Transfer canceled, hangup our threeway channel\n");
+		if (sub->owner) {
+			swap_subs(sub, sub_trans);
+			ast_moh_stop(ast_bridged_channel(sub_trans->owner));
+			sub_trans->moh = 0;
+			sub_trans->subtype = SUB_REAL;
+			sub->subtype = SUB_THREEWAY;
+			ast_queue_hangup_with_cause(sub->owner, AST_CAUSE_NORMAL_CLEARING);
+                } else
+			ast_log(LOG_WARNING, "Canceling a threeway channel without owner\n");
+		return;
+	}
+}
+
 /* From phone to PBX */
-static void HandleCallOutgoing(struct unistimsession *s)
+static void handle_call_outgoing(struct unistimsession *s)
 {
 	struct ast_channel *c;
 	struct unistim_subchannel *sub;
-	pthread_t t;
+	int softkey;
+
 	s->state = STATE_CALL;
-	sub = s->device->lines->subs[SUB_REAL];
-	if (!sub) {
-		ast_log(LOG_NOTICE, "No available lines on: %s\n", s->device->name);
+	s->sout.sin_family = AF_INET;
+
+	sub = get_sub(s->device, SUB_THREEWAY);
+	if (sub) {
+		/* If sub for threway call created than we use transfer behaviuor */
+		struct unistim_subchannel *sub_trans = NULL;
+		struct unistim_device *d = s->device;
+
+		sub_trans = get_sub(d, SUB_REAL);
+		if (sub_trans) {
+			ast_log(LOG_WARNING, "Can't transfer while active subchannel exists!\n");
+			return;
+		}
+		if (!sub->owner) {
+			ast_log(LOG_WARNING, "Unable to find subchannel with music on hold\n");
+			return;
+		}
+
+		sub_trans = unistim_alloc_sub(d, SUB_REAL);
+		if (!sub_trans) {
+			ast_log(LOG_WARNING, "Unable to allocate three-way subchannel\n");
+			return;
+		}
+		sub_trans->parent = sub->parent;
+		sub_stop_silence(s, sub);
+		send_tone(s, 0, 0);
+		/* Make new channel */
+		c = unistim_new(sub_trans, AST_STATE_DOWN, NULL);
+		if (!c) {
+			ast_log(LOG_WARNING, "Cannot allocate new structure on channel %p\n", sub->parent);
+			return;
+		}
+		/* Swap things around between the three-way and real call */
+		swap_subs(sub, sub_trans);
+		send_select_output(s, s->device->output, s->device->volume, MUTE_OFF);
+		if (s->device->height == 1) {
+			send_text(TEXT_LINE0, TEXT_NORMAL, s, s->device->phone_number);
+		} else {
+			send_text(TEXT_LINE0, TEXT_NORMAL, s, ustmtext("Calling (pre-transfer)", s));
+			send_text(TEXT_LINE1, TEXT_NORMAL, s, s->device->phone_number);
+			send_text(TEXT_LINE2, TEXT_NORMAL, s, ustmtext("Dialing...", s));
+		}
+		send_text_status(s, ustmtext("TransfrCancel", s));
+
+		if (ast_pthread_create(&sub->ss_thread, NULL, unistim_ss, c)) {
+			ast_log(LOG_WARNING, "Unable to start simple switch on channel %p\n", c);
+			sub->ss_thread = AST_PTHREADT_NULL;
+			ast_hangup(c);
+			return;
+		}
+		if (unistimdebug)
+			ast_verb(0, "Started three way call on channel %p (%s) subchan %d\n",
+				 sub_trans->owner, sub_trans->owner->name, sub_trans->subtype);
 		return;
 	}
+
+	softkey = get_avail_softkey(s, NULL);
+	if (softkey == -1) {
+		ast_log(LOG_WARNING, "Have no avail softkey for calling\n");
+		return;
+	}
+	sub = get_sub(s->device, SUB_REAL);
+	if (sub) { /* have already call assigned */
+		sub_hold(s, sub); /* Need to put on hold */
+	}
+	sub = unistim_alloc_sub(s->device, SUB_REAL);
+	sub->parent = s->device->sline[softkey];
+	s->device->ssub[softkey] = sub;
+	sub->softkey = softkey;
+
+	if (unistimdebug)
+		ast_verb(0, "Using softkey %d, line %p\n", sub->softkey, sub->parent);
+	send_favorite_short(sub->softkey, FAV_ICON_OFFHOOK_BLACK, s);
+	s->device->selected = -1;
 	if (!sub->owner) {		      /* A call is already in progress ? */
 		c = unistim_new(sub, AST_STATE_DOWN, NULL);   /* No, starting a new one */
-		if (c) {
-			/* Need to start RTP before calling ast_pbx_run */
-			if (!sub->rtp)
-				start_rtp(sub);
-			send_select_output(s, s->device->output, s->device->volume, MUTE_OFF);
+		if (!sub->rtp) /* Need to start RTP before calling ast_pbx_run */
+			start_rtp(sub);
+		if (!strcmp(s->device->phone_number, ast_pickup_ext())) {
+			if (unistimdebug)
+				ast_verb(0, "Try to pickup in unistim_new\n");
 
+			send_text(TEXT_LINE0, TEXT_NORMAL, s, "");
+			send_text_status(s, ustmtext("       Transf        Hangup", s));
+			send_start_timer(s);
+			if (ast_pickup_call(c)) {
+				ast_log(LOG_NOTICE, "Nothing to pick up\n");
+				c->hangupcause = AST_CAUSE_CALL_REJECTED;
+			} else {
+				c->hangupcause = AST_CAUSE_NORMAL_CLEARING;
+			}
+			ast_hangup(c);
+			c = NULL;
+                } else if (c) {
+			send_select_output(s, s->device->output, s->device->volume, MUTE_OFF);
+			send_tone(s, 0, 0); /* Dialing empty number should also stop dial tone */
 			if (s->device->height == 1) {
-				send_text(TEXT_LINE0, TEXT_NORMAL, s, s->device->phone_number);
+				if (strlen(s->device->phone_number) > 0) {
+					send_text(TEXT_LINE0, TEXT_NORMAL, s, s->device->phone_number);
+				} else {
+					send_text(TEXT_LINE0, TEXT_NORMAL, s, ustmtext("Calling...", s));
+				}
 			} else {
-				send_text(TEXT_LINE0, TEXT_NORMAL, s, "Calling :");
+				send_text(TEXT_LINE0, TEXT_NORMAL, s, ustmtext("Calling :", s));
 				send_text(TEXT_LINE1, TEXT_NORMAL, s, s->device->phone_number);
-				send_text(TEXT_LINE2, TEXT_NORMAL, s, "Dialing...");
+				send_text(TEXT_LINE2, TEXT_NORMAL, s, ustmtext("Dialing...", s));
 			}
-			send_text_status(s, "Hangup");
+			send_text_status(s, ustmtext("                     Hangup", s));
 
 			/* start switch */
-			if (ast_pthread_create(&t, NULL, unistim_ss, c)) {
-				display_last_error("Unable to create switch thread");
+			if (ast_pthread_create(&sub->ss_thread, NULL, unistim_ss, c)) {
+				ast_log(LOG_WARNING, "Unable to create switch thread\n");
+				sub->ss_thread = AST_PTHREADT_NULL;
 				ast_queue_hangup_with_cause(c, AST_CAUSE_SWITCH_CONGESTION);
 			}
 		} else
 			ast_log(LOG_WARNING, "Unable to create channel for %s@%s\n",
 					sub->parent->name, s->device->name);
-	} else {					/* We already have a call, so we switch in a threeway call */
-
-		if (s->device->moh) {
-			struct unistim_subchannel *subchannel;
-			struct unistim_line *p = s->device->lines;
-			subchannel = p->subs[SUB_REAL];
-
-			if (!subchannel->owner) {
-				ast_log(LOG_WARNING, "Unable to find subchannel for music on hold\n");
-				return;
-			}
-			if (p->subs[SUB_THREEWAY]) {
-				ast_log(LOG_WARNING,
-						"Can't transfer while an another transfer is taking place\n");
-				return;
-			}
-			if (!alloc_sub(p, SUB_THREEWAY)) {
-				ast_log(LOG_WARNING, "Unable to allocate three-way subchannel\n");
-				return;
-			}
-			/* Stop the silence generator */
-			if (s->device->silence_generator) {
-				if (unistimdebug)
-					ast_verb(0, "Stopping silence generator\n");
-				ast_channel_stop_silence_generator(subchannel->owner,
-												   s->device->silence_generator);
-				s->device->silence_generator = NULL;
-			}
-			send_tone(s, 0, 0);
-			/* Make new channel */
-			c = unistim_new(p->subs[SUB_THREEWAY], AST_STATE_DOWN, NULL);
-			if (!c) {
-				ast_log(LOG_WARNING, "Cannot allocate new structure on channel %p\n", p);
-				return;
-			}
-			/* Swap things around between the three-way and real call */
-			swap_subs(p, SUB_THREEWAY, SUB_REAL);
-			send_select_output(s, s->device->output, s->device->volume, MUTE_OFF);
-
-			if (s->device->height == 1) {
-				send_text(TEXT_LINE0, TEXT_NORMAL, s, s->device->phone_number);
-			} else {
-				send_text(TEXT_LINE0, TEXT_NORMAL, s, "Calling (pre-transfer)");
-				send_text(TEXT_LINE1, TEXT_NORMAL, s, s->device->phone_number);
-				send_text(TEXT_LINE2, TEXT_NORMAL, s, "Dialing...");
-			}
-			send_text_status(s, "TransfrCancel");
-
-			if (ast_pthread_create(&t, NULL, unistim_ss, p->subs[SUB_THREEWAY]->owner)) {
-				ast_log(LOG_WARNING, "Unable to start simple switch on channel %p\n", p);
-				ast_hangup(c);
-				return;
-			}
-			if (unistimdebug)
-				ast_verb(0, "Started three way call on channel %p (%s) subchan %d\n",
-					 p->subs[SUB_THREEWAY]->owner, p->subs[SUB_THREEWAY]->owner->name,
-					 p->subs[SUB_THREEWAY]->subtype);
-		} else
-			ast_debug(1, "Current sub [%s] already has owner\n", sub->owner->name);
+	} else {
+		ast_debug(1, "Current sub [%s] already has owner\n", sub->owner->name);
 	}
 	return;
 }
 
 /* From PBX to phone */
-static void HandleCallIncoming(struct unistimsession *s)
+static void handle_call_incoming(struct unistimsession *s)
 {
-	struct unistim_subchannel *sub;
+	struct unistim_subchannel *sub = NULL;
+	int i;
+
 	s->state = STATE_CALL;
 	s->device->missed_call = 0;
 	send_no_ring(s);
-	sub = s->device->lines->subs[SUB_REAL];
+	sub = get_sub(s->device, SUB_RING); /* Put other SUB_REAL call on hold */
 	if (!sub) {
-		ast_log(LOG_NOTICE, "No available lines on: %s\n", s->device->name);
+		ast_log(LOG_WARNING, "No ringing lines on: %s\n", s->device->name);
+		return;
+	}
+	/* Change icons for all ringing keys */
+	for (i = 0; i < FAVNUM; i++) {
+		if (!s->device->ssub[i])  /* No sub assigned - skip */
+			continue;
+		if (s->device->ssub[i]->subtype == SUB_REAL)
+			sub_hold(s, s->device->ssub[i]);
+		if (s->device->ssub[i] != sub)
+			continue;
+		if (sub->softkey == i) /* If softkey assigned at this moment - do not erase */
+			continue;
+		if (sub->softkey < 0) { /* If softkey not defined - first one used */
+			sub->softkey = i;
+			continue;
+		}
+		send_favorite_short(i, FAV_LINE_ICON, s);
+		s->device->ssub[i] = NULL;
+	}
+	if (sub->softkey < 0) {
+		ast_log(LOG_WARNING, "Can not assign softkey for incoming call on: %s\n", s->device->name);
 		return;
-	} else if (unistimdebug)
+	}
+	send_favorite_short(sub->softkey, FAV_ICON_OFFHOOK_BLACK, s);
+	sub->parent = s->device->sline[sub->softkey];
+	sub->subtype = SUB_REAL;
+	if (unistimdebug)
 		ast_verb(0, "Handle Call Incoming for %s@%s\n", sub->parent->name,
 					s->device->name);
 	start_rtp(sub);
 	if (!sub->rtp)
 		ast_log(LOG_WARNING, "Unable to create channel for %s@%s\n", sub->parent->name,
 				s->device->name);
-	ast_queue_control(sub->owner, AST_CONTROL_ANSWER);
-	send_text(TEXT_LINE2, TEXT_NORMAL, s, "is on-line");
-	send_text_status(s, "Hangup Transf");
+	if (sub->owner) {
+		ast_queue_control(sub->owner, AST_CONTROL_ANSWER);
+	}
+	send_text(TEXT_LINE2, TEXT_NORMAL, s, ustmtext("is on-line", s));
+	send_text_status(s, ustmtext("       Transf        Hangup", s));
 	send_start_timer(s);
 
 	if ((s->device->output == OUTPUT_HANDSET) &&
@@ -2511,7 +3064,6 @@
 		send_select_output(s, OUTPUT_SPEAKER, s->device->volume, MUTE_OFF);
 	else
 		send_select_output(s, s->device->output, s->device->volume, MUTE_OFF);
-	s->device->start_call_timestamp = time(0);
 	write_history(s, 'i', 0);
 	return;
 }
@@ -2520,8 +3072,10 @@
 {
 	struct ast_frame f = { .frametype = AST_FRAME_DTMF, .subclass.integer = digit, .src = "unistim" };
 	struct unistim_subchannel *sub;
-	sub = pte->device->lines->subs[SUB_REAL];
-	if (!sub->owner || sub->alreadygone) {
+        int row, col;
+
+	sub = get_sub(pte->device, SUB_REAL);
+	if (!sub || !sub->owner || sub->alreadygone) {
 		ast_log(LOG_WARNING, "Unable to find subchannel in dtmf senddigit\n");
 		return -1;
 	}
@@ -2531,65 +3085,80 @@
 
 	if (unistimdebug)
 		ast_verb(0, "Send Digit %c\n", digit);
-	switch (digit) {
-	case '0':
-		send_tone(pte, 941, 1336);
-		break;
-	case '1':
-		send_tone(pte, 697, 1209);
-		break;
-	case '2':
-		send_tone(pte, 697, 1336);
-		break;
-	case '3':
-		send_tone(pte, 697, 1477);
-		break;
-	case '4':
-		send_tone(pte, 770, 1209);
-		break;
-	case '5':
-		send_tone(pte, 770, 1336);
-		break;
-	case '6':
-		send_tone(pte, 770, 1477);
-		break;
-	case '7':
-		send_tone(pte, 852, 1209);
-		break;
-	case '8':
-		send_tone(pte, 852, 1336);
-		break;
-	case '9':
-		send_tone(pte, 852, 1477);
-		break;
-	case 'A':
-		send_tone(pte, 697, 1633);
-		break;
-	case 'B':
-		send_tone(pte, 770, 1633);
-		break;
-	case 'C':
-		send_tone(pte, 852, 1633);
-		break;
-	case 'D':
-		send_tone(pte, 941, 1633);
-		break;
-	case '*':
-		send_tone(pte, 941, 1209);
-		break;
-	case '#':
-		send_tone(pte, 941, 1477);
-		break;
-	default:
+
+	row = (digit-'1')%3;
+	col = (digit-'1'-row)/3;
+	if (digit >= '1' && digit <='9')
+		send_tone(pte, dtmf_row[row], dtmf_col[col]);
+	else if (digit >= 'A' && digit <= 'D')
+		send_tone(pte, dtmf_row[digit-'A'], dtmf_col[3]);
+	else if (digit == '*')
+		send_tone(pte, dtmf_row[3], dtmf_col[0]);
+	else if (digit == '0')
+		send_tone(pte, dtmf_row[3], dtmf_col[1]);
+	else if (digit == '#')
+		send_tone(pte, dtmf_row[3], dtmf_col[2]);
+	else
 		send_tone(pte, 500, 2000);
-	}
+
 	usleep(150000);			 /* XXX Less than perfect, blocking an important thread is not a good idea */
 	send_tone(pte, 0, 0);
 	return 0;
 }
 
+static void handle_key_fav(struct unistimsession *pte, char keycode) 
+{
+	int keynum = keycode - KEY_FAV0;
+	struct unistim_subchannel *sub;
+
+	sub = get_sub(pte->device, SUB_REAL);
+
+	/* Make an action on selected favorite key */
+	if (!pte->device->ssub[keynum]) { /* Key have no assigned call */
+		send_favorite_selected(FAV_LINE_ICON, pte);
+		if (is_key_line(pte->device, keynum)) {
+			if (unistimdebug)
+				ast_verb(0, "Handle line w/o sub - dialpage\n");
+			pte->device->selected = keynum;
+			sub_hold(pte, sub); /* Put active call on hold */
+			send_stop_timer(pte);
+			handle_dial_page(pte);
+		} else if (is_key_favorite(pte->device, keynum)) {
+			/* Put active call on hold in handle_call_outgoing function, after preparation and
+			 checking if lines available for calling */
+			if (unistimdebug)
+				ast_verb(0, "Handle favorite w/o sub - dialing\n");
+			if ((pte->device->output == OUTPUT_HANDSET) &&
+				(pte->device->receiver_state == STATE_ONHOOK))
+				send_select_output(pte, OUTPUT_SPEAKER, pte->device->volume, MUTE_OFF);
+			else
+				send_select_output(pte, pte->device->output, pte->device->volume, MUTE_OFF);
+
+			key_favorite(pte, keycode);
+		}
+	} else {
+		sub = pte->device->ssub[keynum];
+		/* Favicon have assigned sub, activate it and put current on hold */
+		if (sub->subtype == SUB_REAL) {
+			sub_hold(pte, sub);
+			show_main_page(pte);
+		} else if (sub->subtype == SUB_RING) {
+			sub->softkey = keynum;
+			handle_call_incoming(pte);
+		} else if (sub->subtype == SUB_ONHOLD) {
+			if (pte->state == STATE_DIALPAGE){
+				send_tone(pte, 0, 0);
+			}
+			send_callerid_screen(pte, sub);
+			sub_unhold(pte, sub);
+			pte->state = STATE_CALL;
+		}
+	}
+}
+
 static void key_call(struct unistimsession *pte, char keycode)
 {
+	struct unistim_subchannel *sub = NULL;
 	if ((keycode >= KEY_0) && (keycode <= KEY_SHARP)) {
 		if (keycode == KEY_SHARP)
 			keycode = '#';
@@ -2601,12 +3170,31 @@
 		return;
 	}
 	switch (keycode) {
-	case KEY_HANGUP:
-	case KEY_FUNC1:
-		close_call(pte);
+	case KEY_FUNC1: 
+		if (get_sub(pte->device, SUB_THREEWAY)) {
+			close_call(pte);
+		}
 		break;
 	case KEY_FUNC2:
-		TransferCallStep1(pte);
+		if (get_sub(pte->device, SUB_THREEWAY)) {
+			transfer_cancel_step2(pte);
+		} else {
+			transfer_call_step1(pte);
+		}
+		break;
+	case KEY_HANGUP:
+	case KEY_FUNC4: 
+		if (!get_sub(pte->device, SUB_THREEWAY)) {
+			close_call(pte);
+		}
+		break;
+	case KEY_FAV0:
+	case KEY_FAV1:
+	case KEY_FAV2:
+	case KEY_FAV3:
+	case KEY_FAV4:
+	case KEY_FAV5:
+		handle_key_fav(pte, keycode);
 		break;
 	case KEY_HEADPHN:
 		if (pte->device->output == OUTPUT_HEADPHONE)
@@ -2622,82 +3210,83 @@
 							 MUTE_OFF);
 		break;
 	case KEY_MUTE:
-		if (!pte->device->moh) {
+		sub = get_sub(pte->device, SUB_REAL);
+		if (!sub || !sub->owner) {
+			ast_log(LOG_WARNING, "Unable to find subchannel for music on hold\n");
+			return;
+		}
+		if (!sub->moh) {
 			if (pte->device->mute == MUTE_ON)
 				send_select_output(pte, pte->device->output, pte->device->volume, MUTE_OFF);
 			else
 				send_select_output(pte, pte->device->output, pte->device->volume, MUTE_ON);
 			break;
 		}
+		break;
 	case KEY_ONHOLD:
-		{
-			struct unistim_subchannel *sub;
-			struct ast_channel *bridgepeer = NULL;
-			sub = pte->device->lines->subs[SUB_REAL];
-			if (!sub->owner) {
-				ast_log(LOG_WARNING, "Unable to find subchannel for music on hold\n");
-				return;
+		sub = get_sub(pte->device, SUB_REAL);
+		if (!sub) {
+			if(pte->device->ssub[pte->device->selected]) {
+				sub_hold(pte, pte->device->ssub[pte->device->selected]);
 			}
-			if ((bridgepeer = ast_bridged_channel(sub->owner))) {
-				if (pte->device->moh) {
-					ast_moh_stop(bridgepeer);
-					pte->device->moh = 0;
-					send_select_output(pte, pte->device->output, pte->device->volume,
-									 MUTE_OFF);
-				} else {
-					ast_moh_start(bridgepeer, pte->device->lines->musicclass, NULL);
-					pte->device->moh = 1;
-					send_select_output(pte, pte->device->output, pte->device->volume,
-									 MUTE_ON);
-				}
-			} else
-				ast_log(LOG_WARNING,
-						"Unable to find peer subchannel for music on hold\n");
-			break;
-		}
+		} else
+			sub_hold(pte, sub);
+		break;
 	}
 	return;
 }
 
 static void key_ringing(struct unistimsession *pte, char keycode)
 {
-	if (keycode == KEY_FAV0 + pte->device->softkeylinepos) {
-		HandleCallIncoming(pte);
-		return;
-	}
 	switch (keycode) {
+	case KEY_FAV0:
+	case KEY_FAV1:
+	case KEY_FAV2:
+	case KEY_FAV3:
+	case KEY_FAV4:
+	case KEY_FAV5:
+		handle_key_fav(pte, keycode);
+		break;
+	case KEY_FUNC3:
+		ignore_call(pte);
+		break;
 	case KEY_HANGUP:
 	case KEY_FUNC4:
-		IgnoreCall(pte);
+		discard_call(pte);
 		break;
 	case KEY_FUNC1:
-		HandleCallIncoming(pte);
+		handle_call_incoming(pte);
+		break;
+	case KEY_LOUDSPK:
+		pte->device->output = OUTPUT_SPEAKER;
+		handle_call_incoming(pte);
+		break;
+	case KEY_HEADPHN:
+		pte->device->output = OUTPUT_HEADPHONE;
+		handle_call_incoming(pte);
 		break;
 	}
 	return;
 }
 
-static void Keyfavorite(struct unistimsession *pte, char keycode)
+static void key_favorite(struct unistimsession *pte, char keycode)
 {
-	int fav;
-
-	if ((keycode < KEY_FAV1) && (keycode > KEY_FAV5)) {
+	int fav = keycode - KEY_FAV0;
+	if (!is_key_favorite(pte->device, fav)) {
 		ast_log(LOG_WARNING, "It's not a favorite key\n");
 		return;
 	}
-	if (keycode == KEY_FAV0)
-		return;
-	fav = keycode - KEY_FAV0;
-	if (pte->device->softkeyicon[fav] == 0)
-		return;
 	ast_copy_string(pte->device->phone_number, pte->device->softkeynumber[fav],
 					sizeof(pte->device->phone_number));
-	HandleCallOutgoing(pte);
+	handle_call_outgoing(pte);
 	return;
 }
 
 static void key_dial_page(struct unistimsession *pte, char keycode)
 {
+	struct unistim_subchannel *sub = get_sub(pte->device, SUB_THREEWAY);
+
+	pte->device->nextdial = 0;
 	if (keycode == KEY_FUNC3) {
 		if (pte->device->size_phone_number <= 1)
 			keycode = KEY_FUNC4;
